/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.143 by edhill, Tue Feb 14 16:21:09 2006 UTC revision 1.164 by ce107, Tue Jul 31 22:27:01 2007 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24  }  }
25    
26  # Search for particular CPP #cmds associated with MPI  # Search for particular CPP #cmds associated with MPI
27  # usage: test_for_mpi_in_cpp_eeoptions CPP_file  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28  test_for_mpi_in_cpp_eeoptions() {  test_for_mpi_in_cpp_eeoptions() {
29      cpp_options=$1      cpp_options=$1
30      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38  }  }
39    
40  # Search for particular string in a file. Return 1 if detected, 0 if not  # Search for particular string in a file. Return 1 if detected, 0 if not
# Line 39  test_for_string_in_file() { Line 47  test_for_string_in_file() {
47      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
48          printf "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
49          grep -i "$strng" $file          grep -i "$strng" $file
50          return 1          exit 99
51      fi      fi
52      return 0      return 0
53  }  }
# Line 317  find_possible_configs()  { Line 325  find_possible_configs()  {
325    
326      #================================================================      #================================================================
327      #  look for possible C compilers      #  look for possible C compilers
328      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329      p_CC=      p_CC=
330      for c in $tmp ; do      for c in $tmp ; do
331          rm -f ./genmake_hello.c  ./genmake_hello          rm -f ./genmake_hello.c  ./genmake_hello
# Line 356  EOF Line 364  EOF
364    
365      #================================================================      #================================================================
366      #  look for possible FORTRAN compilers      #  look for possible FORTRAN compilers
367      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95 gfortran"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368      p_FC=      p_FC=
369      for c in $tmp ; do      for c in $tmp ; do
370          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 579  Usage: "$0" [OPTIONS] Line 587  Usage: "$0" [OPTIONS]
587      -ts | --ts      -ts | --ts
588            Produce timing information per timestep            Produce timing information per timestep
589      -papis | --papis      -papis | --papis
590            Produce summary MFlop/s with PAPI per timestep            Produce summary MFlop/s (and IPC) with PAPI per timestep
591        -pcls | --pcls
592              Produce summary MFlop/s etc. with PCL per timestep
593      -foolad | --foolad      -foolad | --foolad
594            Fool the AD code generator            Fool the AD code generator
595      -papi | --papi      -papi | --papi
596            Performance analysis with PAPI            Performance analysis with PAPI
597        -pcl | --pcl
598              Performance analysis with PCL
599      -hpmt | --hpmt      -hpmt | --hpmt
600            Performance analysis with the HPM Toolkit            Performance analysis with the HPM Toolkit
601    
602      -gsl | --gsl      -gsl | --gsl
603            Use GSL to control floating point rounding and precision            Use GSL to control floating point rounding and precision
604        -devel | --devel
605              Add additional warning and debugging flags for development
606    
607      -mpi | --mpi      -mpi | --mpi
608            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
# Line 742  EOF Line 756  EOF
756        print *," HELLO WORLD", wtime        print *," HELLO WORLD", wtime
757        end        end
758  EOF  EOF
759      $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_warnings 2>&1      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
760        echo $COMM >> genmake_warnings
761        $COMM >> genmake_warnings 2>&1
762      RET_F=$?      RET_F=$?
763      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1
764      RETVAL=$?      RETVAL=$?
# Line 755  EOF Line 771  EOF
771    
772    
773  check_HAVE_SIGREG()  {  check_HAVE_SIGREG()  {
774        if test ! "x$HAVE_SIGREG" = x ; then
775            return
776        fi
777      get_fortran_c_namemangling      get_fortran_c_namemangling
778      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
779  $FC_NAMEMANGLE  $FC_NAMEMANGLE
# Line 812  EOF Line 831  EOF
831    
832    
833  check_HAVE_SETRLSTK()  {  check_HAVE_SETRLSTK()  {
834        if test "x$HAVE_SETRLSTK" = xt ; then
835            DEFINES="$DEFINES -DHAVE_SETRLSTK"
836            return
837        fi  
838        if test ! "x$HAVE_SETRLSTK" = x ; then
839            return
840        fi
841      get_fortran_c_namemangling      get_fortran_c_namemangling
842      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
843  $FC_NAMEMANGLE  $FC_NAMEMANGLE
# Line 922  EOF Line 948  EOF
948      cat genmake_tnc.F >> genmake_tnc.log      cat genmake_tnc.F >> genmake_tnc.log
949      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log
950      RET_CPP=f      RET_CPP=f
951      COMM="$CPP $DEFINES $INCLUDES genmake_tnc.F"      COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
952      echo "$COMM" >> genmake_tnc.log      echo "$COMM" >> genmake_tnc.log
953      $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t      eval $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t
954      if test "x$RET_CPP" = xf ; then      if test "x$RET_CPP" = xf ; then
955          echo "  WARNING: CPP failed to pre-process the netcdf test." \          echo "  WARNING: CPP failed to pre-process the netcdf test." \
956              >> genmake_tnc.log              >> genmake_tnc.log
# Line 932  EOF Line 958  EOF
958              >> genmake_tnc.log              >> genmake_tnc.log
959      fi      fi
960      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log
961      echo "  &&  $LINK -o genmake_tnc.o $LIBS" >> genmake_tnc.log      echo "  &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
962      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
963          &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1          &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
964      RET_COMPILE=$?      RET_COMPILE=$?
965      cat genmake_tnc.log >> genmake_warnings      cat genmake_tnc.log >> genmake_warnings
966    
# Line 950  EOF Line 976  EOF
976      else      else
977          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
978          echo "try again with added '-lnetcdf'" > genmake_tnc.log          echo "try again with added '-lnetcdf'" > genmake_tnc.log
979          echo "$CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS \ " >> genmake_tnc.log          echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
980          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
981          echo " &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log          echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
982          $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS 2>/dev/null  \          cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
983              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
984              &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1              &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
985          RET_COMPILE=$?          RET_COMPILE=$?
986          cat genmake_tnc.log >> genmake_warnings          cat genmake_tnc.log >> genmake_warnings
987          if test "x$RET_COMPILE" = x0 ; then          if test "x$RET_COMPILE" = x0 ; then
988              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
989              HAVE_NETCDF=t              HAVE_NETCDF=t
990            else
991            # try again with "-lnetcdff" added to the libs
992                echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
993                echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
994                echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
995                echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
996                cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
997                    &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
998                    &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
999                RET_COMPILE=$?
1000                cat genmake_tnc.log >> genmake_warnings
1001                if test "x$RET_COMPILE" = x0 ; then
1002                    LIBS="$LIBS -lnetcdff -lnetcdf"
1003                    HAVE_NETCDF=t
1004                fi
1005          fi          fi
1006      fi      fi
1007      rm -f genmake_tnc*      rm -f genmake_tnc*
# Line 1008  MPI= Line 1049  MPI=
1049  MPIPATH=  MPIPATH=
1050  TS=  TS=
1051  PAPIS=  PAPIS=
1052    PCLS=
1053  FOOLAD=  FOOLAD=
1054  PAPI=  PAPI=
1055    PCL=
1056  HPMT=  HPMT=
1057  GSL=  GSL=
1058    DEVEL=
1059  HAVE_TEST_L=  HAVE_TEST_L=
1060    
1061  # DEFINES checked by test compilation or command-line  # DEFINES checked by test compilation or command-line
# Line 1019  HAVE_SYSTEM= Line 1063  HAVE_SYSTEM=
1063  HAVE_FDATE=  HAVE_FDATE=
1064  FC_NAMEMANGLE=  FC_NAMEMANGLE=
1065  HAVE_CLOC=  HAVE_CLOC=
1066  HAVE_SETRLSTK=  # HAVE_SETRLSTK=
1067  HAVE_STAT=  HAVE_STAT=
1068  HAVE_NETCDF=  HAVE_NETCDF=
1069  HAVE_ETIME=  HAVE_ETIME=
# Line 1070  TAMC_EXTRA= Line 1114  TAMC_EXTRA=
1114    
1115  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1116  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1117  gm_s2="FC CPP IEEE TS PAPIS PAPI HPMT GSL MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI JAM DUMPSTATE STANDARDDIRS"
1118    
1119  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1120  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
# Line 1254  for ac_option in "$@" ; do Line 1298  for ac_option in "$@" ; do
1298              TS=true ;;              TS=true ;;
1299          -papis | --papis)          -papis | --papis)
1300              PAPIS=true ;;              PAPIS=true ;;
1301            -pcls | --pcls)
1302                PCLS=true ;;
1303          -foolad | --foolad)          -foolad | --foolad)
1304              FOOLAD=true ;;              FOOLAD=true ;;
1305          -papi | --papi)          -papi | --papi)
1306              PAPI=true ;;              PAPI=true ;;
1307            -pcl | --pcl)
1308                PCL=true ;;
1309          -hpmt | --hpmt)          -hpmt | --hpmt)
1310              HPMT=true ;;              HPMT=true ;;
1311    
1312          -gsl | --gsl)          -gsl | --gsl)
1313              GSL=true ;;              GSL=true ;;
1314    
1315            -devel | --devel)
1316                DEVEL=true ;;
1317    
1318          -mpi | --mpi)          -mpi | --mpi)
1319              MPI=true ;;              MPI=true ;;
1320          -mpi=* | --mpi=*)          -mpi=* | --mpi=*)
# Line 1312  done Line 1363  done
1363  if test -f ./.genmakerc ; then  if test -f ./.genmakerc ; then
1364      echo      echo
1365      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1366      echo "  file.  This file format is no longer supported.  Please see:"      echo "  file.  This file format is no longer supported.  For directions on"
1367      echo      echo "  how to setup and use the new \"genmake2\" script, please see:"
1368      echo "    http://mitgcm.org/devel_HOWTO/"      echo "    http://mitgcm.org/devel_HOWTO/"
1369      echo      echo "  and send an email to MITgcm-support@mitgcm.org if you need help."
1370      echo "  for directions on how to setup and use the new \"genmake2\" input"      echo "WARNING: ignore \"./.genmakerc\" and continue."
     echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."  
1371      echo      echo
1372  fi  fi
1373    
1374  #  Find the MITgcm ${ROOTDIR}  #  Find the MITgcm ${ROOTDIR}
1375  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1376      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1377      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1378          ROOTDIR=".."          ROOTDIR=".."
1379      else      else
1380          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
# Line 1514  if test ! "x$TS" = x ; then Line 1564  if test ! "x$TS" = x ; then
1564        else        else
1565              DEFINES="$DEFINES -DTIME_PER_TIMESTEP"              DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1566        fi        fi
1567          PACKAGES="$PACKAGES showflops"
1568  fi  fi
1569  if test ! "x$PAPIS" = x ; then  if test ! "x$PAPIS" = x ; then
1570        echo "  Turning on PAPI flop summary per timestep"        echo "  Turning on PAPI flop summary per timestep"
# Line 1525  if test ! "x$PAPIS" = x ; then Line 1576  if test ! "x$PAPIS" = x ; then
1576        fi        fi
1577        INCLUDES="$INCLUDES $PAPIINC"        INCLUDES="$INCLUDES $PAPIINC"
1578        LIBS="$LIBS $PAPILIB"        LIBS="$LIBS $PAPILIB"
1579          PACKAGES="$PACKAGES showflops"
1580    fi
1581    if test ! "x$PCLS" = x ; then
1582          echo "  Turning on PCL counter summary per timestep"
1583          echo "  Please make sure PCLINC, PCLLIB are defined"
1584          if test ! "x$FOOLAD" = x ; then
1585                DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1586          else
1587                DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1588          fi
1589          INCLUDES="$INCLUDES $PCLINC"
1590          LIBS="$LIBS $PCLLIB"
1591          PACKAGES="$PACKAGES showflops"
1592  fi  fi
1593  if test ! "x$PAPI" = x ; then  if test ! "x$PAPI" = x ; then
1594        if test ! "x$PAPIS" = x ; then        if test ! "x$PAPIS" = x ; then
# Line 1538  if test ! "x$PAPI" = x ; then Line 1602  if test ! "x$PAPI" = x ; then
1602            LIBS="$LIBS $PAPILIB"            LIBS="$LIBS $PAPILIB"
1603        fi        fi
1604  fi  fi
1605    if test ! "x$PCL" = x ; then
1606          if test ! "x$PCLS" = x ; then
1607              echo "  PCL performance analysis and flop summary per timestep cannot co-exist!"
1608              echo "  Sticking with PCL flop summary per timestep!"
1609          else
1610              echo "  Turning on performance analysis with PCL"
1611              echo "  Please make sure PCLINC, PCLLIB are defined"
1612              DEFINES="$DEFINES -DUSE_PCL"
1613              INCLUDES="$INCLUDES $PCLINC"
1614              LIBS="$LIBS $PCLLIB"
1615          fi
1616    fi
1617  if test ! "x$HPMT" = x ; then  if test ! "x$HPMT" = x ; then
1618        if test ! "x$PAPI" = x ; then        if test ! "x$PAPI" = x ; then
1619            echo "  PAPI and the HPM Toolkit cannot co-exist!"            echo "  PAPI and the HPM Toolkit cannot co-exist!"
1620            echo "  Sticking with PAPI!"            echo "  Sticking with PAPI!"
1621          else if test ! "x$PCL" = x ; then
1622              echo "  PCL and the HPM Toolkit cannot co-exist!"
1623              echo "  Sticking with PCL!"
1624        else        else
1625            echo "  Turning on performance analysis with the HPM Toolkit"            echo "  Turning on performance analysis with the HPM Toolkit"
1626            echo "  Please make sure HPMTINC, HPMTLIB are defined"            echo "  Please make sure HPMTINC, HPMTLIB are defined"
# Line 1549  if test ! "x$HPMT" = x ; then Line 1628  if test ! "x$HPMT" = x ; then
1628            INCLUDES="$INCLUDES $HPMTINC"            INCLUDES="$INCLUDES $HPMTINC"
1629            LIBS="$LIBS $HPMTLIB"            LIBS="$LIBS $HPMTLIB"
1630        fi        fi
1631          fi
1632  fi  fi
1633  if test ! "x$GSL" = x ; then  if test ! "x$GSL" = x ; then
1634        echo "  Turning on use of GSL to control floating point calculations"        echo "  Turning on use of GSL to control floating point calculations"
# Line 1636  rm -f genmake_t* Line 1716  rm -f genmake_t*
1716    
1717  printf "  Can we unlimit the stack size using $FC...  "  printf "  Can we unlimit the stack size using $FC...  "
1718  check_HAVE_SETRLSTK  check_HAVE_SETRLSTK
1719  if test "x$HAVE_SETRLSTK" != x ; then  if test "x$HAVE_SETRLSTK" = xt ; then
1720      echo "yes"      echo "yes"
1721  else  else
1722      echo "no"      echo "no"
# Line 1645  rm -f genmake_t* Line 1725  rm -f genmake_t*
1725    
1726  printf "  Can we register a signal handler using $FC...  "  printf "  Can we register a signal handler using $FC...  "
1727  check_HAVE_SIGREG  check_HAVE_SIGREG
1728  if test "x$HAVE_SIGREG" != x ; then  if test "x$HAVE_SIGREG" = xt ; then
1729      echo "yes"      echo "yes"
1730  else  else
1731      echo "no"      echo "no"
# Line 1763  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1843  if test -r $ROOTDIR"/eesupp/src/Makefile
1843      fi      fi
1844  fi  fi
1845    
1846  #same for exch2  #same for pkg/exch2 and pkg/regrid
1847  if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then  for pdir in exch2 regrid ; do
1848      echo "  Making source files in exch2 from  templates"      if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1849      ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1          echo "  Making source files in pkg/${pdir} from templates"
1850      RETVAL=$?          ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1851      if test "x${RETVAL}" = x0 ; then          RETVAL=$?
1852          rm -f make_exch2.errors          if test "x${RETVAL}" = x0 ; then
1853      else              rm -f make_${pdir}.errors
1854          echo "Error: problem encountered while building source files in exch2:"          else
1855          cat make_exch2.errors 1>&2              echo "Error: problem encountered while building source files in pkg/${pdir}:"
1856          exit 1              cat make_${pdir}.errors 1>&2
1857                exit 1
1858            fi
1859      fi      fi
1860  fi  done
1861    
1862  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1863  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
# Line 1886  done Line 1968  done
1968  rm -f ./.tmp_pack  rm -f ./.tmp_pack
1969  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1970    
1971  #  Check availability of NetCDF and then either build the MNC template  #  Check for package MNC: if NetCDF is available, then build the MNC
1972  #  files or delete mnc from the list of available packages.  #  template files ; otherwise, delete mnc from the list of packages.
1973  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1974  RETVAL=$?  RETVAL=$?
1975  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
# Line 1921  EOF Line 2003  EOF
2003      fi      fi
2004  fi  fi
2005    
2006    #  Check for package PROFILES: if NetCDF is not available,
2007    #  then delete profiles from the list of available packages.
2008    echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2009    RETVAL=$?
2010    if test "x$RETVAL" = x0 ; then
2011        if test "x$HAVE_NETCDF" != xt ; then
2012            cat <<EOF
2013    
2014    *********************************************************************
2015    WARNING: the "profiles" package was enabled but tests failed to
2016      compile NetCDF applications.  Please check that:
2017    
2018      1) NetCDF is correctly installed for this compiler and
2019      2) the LIBS variable (within the "optfile") specifies the correct
2020           NetCDF library to link against.
2021    
2022      Due to this failure, the "profiles" package is now DISABLED.
2023    *********************************************************************
2024    
2025    EOF
2026            PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2027            DISABLE="$DISABLE profiles"
2028        fi
2029    fi
2030    
2031  echo "  applying package dependency rules"  echo "  applying package dependency rules"
2032  ck=  ck=
2033  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
2034      i=0      i=0
2035      # rtot=${#PNAME[@]}      # rtot=${#PNAME[@]}
2036      rtot=$nname      rtot=$nname
2037      while test $i -lt $rtot ; do      while test $i -le $rtot ; do
2038    
2039          #  Is $pname in the current $PACKAGES list?          #  Is $pname in the current $PACKAGES list?
2040          #  pname=${PNAME[$i]}          #  pname=${PNAME[$i]}
# Line 1961  while test "x$ck" != xtt ; do Line 2068  while test "x$ck" != xtt ; do
2068    
2069          #  Do we need to add $dname according to the dependency rules?          #  Do we need to add $dname according to the dependency rules?
2070          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2071                #echo "   " $pname ": need to add :" $dname
2072              in_dis="f"              in_dis="f"
2073              for dis in $DISABLE ; do              for dis in $DISABLE ; do
2074                  if test "x$dis" = "x$dname" ; then                  if test "x$dis" = "x$dname" ; then
# Line 2150  if test ! "x$DIVA" = x ; then Line 2258  if test ! "x$DIVA" = x ; then
2258          perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h          perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2259      else      else
2260          echo " We cannot create a copy of mpif.h!"          echo " We cannot create a copy of mpif.h!"
2261          exit -1  #       exit -1
2262      fi      fi
2263  fi  fi
2264    
# Line 2401  lib: libmitgcmuv.a Line 2509  lib: libmitgcmuv.a
2509    
2510  libmitgcmuv.a: \$(OBJFILES)  libmitgcmuv.a: \$(OBJFILES)
2511          ar rcv libmitgcmuv.a \$(OBJFILES)          ar rcv libmitgcmuv.a \$(OBJFILES)
2512            ar d   libmitgcmuv.a main.o
2513    
2514  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2515    
# Line 2411  output.txt: \$(EXECUTABLE) Line 2520  output.txt: \$(EXECUTABLE)
2520          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2521    
2522  clean:  clean:
2523          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2524            -rm -rf *.o
2525            -rm -rf *.$FS
2526  Clean:  Clean:
2527          @make clean          @make clean
2528          @make cleanlinks          @make cleanlinks
# Line 2422  CLEAN: Line 2533  CLEAN:
2533          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2534          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2535          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2536          -rm -f \$(EXECUTABLE) output.txt STD*          -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2537            -rm -rf mnc_test_*
2538    
2539  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2540  makefile:  makefile:
# Line 2480  cat >>$MAKEFILE <<EOF Line 2592  cat >>$MAKEFILE <<EOF
2592          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2593  .$FS.o:  .$FS.o:
2594          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2595  .F90.$FS90:  .F90.o:  
         \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@  
 .$FS90.o:  
2596          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2597  .c.o:  .c.o:
2598          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
# Line 2509  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF Line 2619  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF
2619  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2620  for i in $ad_vars ; do  for i in $ad_vars ; do
2621      name=$i      name=$i
2622      t1="t2=\$"`echo $i`      t1="t2=\$"`echo "$i"`
2623      eval $t1      eval $t1
2624      printf "%-20s = " $name >> $MAKEFILE      printf "%-20s = " $name >> $MAKEFILE
2625      echo $t2 >> $MAKEFILE      echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2626  done  done
2627    
2628  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
# Line 2529  rm -f ad_files Line 2639  rm -f ad_files
2639  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2640    
2641  # ... AD ...  # ... AD ...
2642  adall: ad_taf  adall: \$(EXE_AD)
2643  adtaf: ad_taf_output.$FS  adtaf: ad_taf_output.$FS
2644  adtamc: ad_tamc_output.$FS  adtamc: ad_tamc_output.$FS
2645    
# Line 2549  adtafonly: Line 2659  adtafonly:
2659          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2660          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2661    
2662  ad_taf: ad_taf_output.o \$(OBJFILES)  \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2663          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2664    
2665  ad_tamc_output.$FS: ad_input_code.$FS  ad_tamc_output.$FS: ad_input_code.$FS
2666          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS

Legend:
Removed from v.1.143  
changed lines
  Added in v.1.164

  ViewVC Help
Powered by ViewVC 1.1.22